
<!DOCTYPE html>

<html class="no-js" lang="en">
<head>
<meta charset="utf-8"/>
<meta content="width=device-width,initial-scale=1" name="viewport"/>
<link href="../assets/images/favicon.png" rel="icon"/>
<meta content="mkdocs-1.2.3, mkdocs-material-7.3.6" name="generator"/>
<title>Conclusion - SecuWallet</title>
<link href="../assets/stylesheets/main.a57b2b03.min.css" rel="stylesheet"/>
<link href="../assets/stylesheets/palette.3f5d1f46.min.css" rel="stylesheet"/>
<meta content="#ab47bd" name="theme-color"/>
<link crossorigin="" href="https://fonts.gstatic.com" rel="preconnect"/>
<link href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700%7CRoboto+Mono&amp;display=fallback" rel="stylesheet"/>
<style>:root{--md-text-font-family:"Roboto";--md-code-font-family:"Roboto Mono"}</style>
<link href="https://unpkg.com/mermaid@8.5.1/dist/mermaid.css" rel="stylesheet"/>
<link href="../extra.css" rel="stylesheet"/>
</head>
<body data-md-color-accent="" data-md-color-primary="purple" data-md-color-scheme="slate" dir="ltr">
<script>function __prefix(e){return new URL("..",location).pathname+"."+e}function __get(e,t=localStorage){return JSON.parse(t.getItem(__prefix(e)))}</script>
<input autocomplete="off" class="md-toggle" data-md-toggle="drawer" id="__drawer" type="checkbox"/>
<input autocomplete="off" class="md-toggle" data-md-toggle="search" id="__search" type="checkbox"/>
<label class="md-overlay" for="__drawer"></label>
<div data-md-component="skip">
<a class="md-skip" href="#conclusion">
          Skip to content
        </a>
</div>
<div data-md-component="announce">
</div>
<header class="md-header" data-md-component="header">
<nav aria-label="Header" class="md-header__inner md-grid">
<a aria-label="SecuWallet" class="md-header__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
<label class="md-header__button md-icon" for="__drawer">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2z"></path></svg>
</label>
<div class="md-header__title" data-md-component="header-title">
<div class="md-header__ellipsis">
<div class="md-header__topic">
<span class="md-ellipsis">
            SecuWallet
          </span>
</div>
<div class="md-header__topic" data-md-component="header-topic">
<span class="md-ellipsis">
            
              Conclusion
            
          </span>
</div>
</div>
</div>
<label class="md-header__button md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
</label>
<div class="md-search" data-md-component="search" role="dialog">
<label class="md-search__overlay" for="__search"></label>
<div class="md-search__inner" role="search">
<form class="md-search__form" name="search">
<input aria-label="Search" autocapitalize="off" autocomplete="off" autocorrect="off" class="md-search__input" data-md-component="search-query" name="query" placeholder="Search" required="" spellcheck="false" type="text"/>
<label class="md-search__icon md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</label>
<nav aria-label="Search" class="md-search__options">
<button aria-label="Clear" class="md-search__icon md-icon" tabindex="-1" type="reset">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z"></path></svg>
</button>
</nav>
</form>
<div class="md-search__output">
<div class="md-search__scrollwrap" data-md-scrollfix="">
<div class="md-search-result" data-md-component="search-result">
<div class="md-search-result__meta">
            Initializing search
          </div>
<ol class="md-search-result__list"></ol>
</div>
</div>
</div>
</div>
</div>
</nav>
</header>
<div class="md-container" data-md-component="container">
<main class="md-main" data-md-component="main">
<div class="md-main__inner md-grid">
<div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Navigation" class="md-nav md-nav--primary" data-md-level="0">
<label class="md-nav__title" for="__drawer">
<a aria-label="SecuWallet" class="md-nav__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
    SecuWallet
  </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../0_Poster/">
        Poster
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../1_Resume/">
        Introduction
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../2_CahierDesCharges/">
        Cahier des charges
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../3_planning/">
        Planning
      </a>
</li>
<li class="md-nav__item md-nav__item--active md-nav__item--nested">
<input checked="" class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" id="__nav_5" type="checkbox"/>
<label class="md-nav__link" for="__nav_5">
          Documentation technique
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Documentation technique" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_5">
<span class="md-nav__icon md-icon"></span>
          Documentation technique
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../4_analyseExistant/">
        Analyse de L'existant
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../5_userStories/">
        User Stories
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../6_interface/">
        Interfaces
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../7_Architecture/">
        Architecture
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../8_outilsExterne/">
        Outils et librairies externes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../9_installationEnvironnement/">
        Installation de l'environnement
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../10_EncryptionBdd/">
        Encryption de base de données
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../docClasse/">
        Description Classes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../Tests/">
        Tests
      </a>
</li>
<li class="md-nav__item md-nav__item--active">
<input class="md-nav__toggle md-toggle" data-md-toggle="toc" id="__toc" type="checkbox"/>
<label class="md-nav__link md-nav__link--active" for="__toc">
          Conclusion
          <span class="md-nav__icon md-icon"></span>
</label>
<a class="md-nav__link md-nav__link--active" href="./">
        Conclusion
      </a>
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#problemes-rencontres">
    Problèmes rencontrés
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#ameliorations-possibles">
    Améliorations possibles
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item md-nav__item--nested">
<input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" id="__nav_6" type="checkbox"/>
<label class="md-nav__link" for="__nav_6">
          Annexes
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Annexes" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_6">
<span class="md-nav__icon md-icon"></span>
          Annexes
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../JournalDeBord/">
        Journal de bord
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../tableDesIllustrations/">
        Table des illustrations
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../planningAnnexe/">
        Planning
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../codeSource/">
        Code source
      </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#problemes-rencontres">
    Problèmes rencontrés
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#ameliorations-possibles">
    Améliorations possibles
  </a>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-content" data-md-component="content">
<article class="md-content__inner md-typeset">
<h1 id="conclusion">Conclusion</h1>
<p>Ce projet était pour moi une bonne opportunité de mettre en pratique mes compétences apprises tout au long de ma formation, mais pas seulement. L'application m'a demandé de me renseigner sur des fonctionnalités que je ne connaissais pas, tel que le type de cryptage possible, ce qui était fort intéressant. De cette manière j'ai dû me questionner pour savoir quel type je voulais utiliser et qui serait le plus indiqué pour celle-ci. Sachant cela, le point fort de mon projet réside dans la sécurité, il était donc préférable de bien me renseigner avant de me lancer dans l'élaboration du programme. D'autant plus qu'il s'agissait de pouvoir obtenir le plus rapidement possible des informations de la blockchain, ce qui demandait également une grande connaissance sur la matière.</p>
<p>Il est vrai que l'utilisation de Google Authenticator était pour ma part une très bonne expérience, puisqu'avec cela j'ai pu obtenir une meilleure compréhension de cette technologie. D'autant plus que cela pourrait fortement m'aider dans des projets futurs.</p>
<p>Le fait d'avoir pu travailler avec une blockchain m'a permis d'en apprendre davantage sur son fonctionnement et de ce qu'elle me permettait de faire. Mais également et surtout de visualiser la structure de données que chaque bloc et transaction contiennent.</p>
<p>J'ai également pu approfondir mes connaissances grâce à l'API PHP qui me permettait d'éviter de faire transiter la clé secrète qui est nécessaire à Google Authenticator, et de cette manière j'ai pu apprendre à lier du code PHP avec un client C#.</p>
<p>Il se trouve que durant l'élaboration de mon projet, j'ai eu besoin d'une API. De ce fait, j'ai été obligé d'être à l'aise avec la programmation asynchrone afin d'éviter des "DeadLock" au sein de mon application.</p>
<p>Je tenais à souligner que ce projet était aussi poussé par une certaine motivation, puisque cette thématique m'intéresse grandement. C'est pour cela que je tenais à mettre en place le plus de fonctionnalités qui s'apparentent aux applications existantes. Je souligne tout de même qu'il s'agit d'une version simplifiée, si j'avais une bonne équipe et plus de temps il aurait été possible de rendre ce projet encore plus conséquent.</p>
<p>À l'heure actuelle l'application est partiellement fonctionnelle et permet donc de répondre à la plupart des exigences de mon cahier des charges.J'estime que si j'avais eu un peu plus de temps, certaines petites parties de mon programme auraient pu être optimisées pour mieux répondre aux exigences et permettre que cela soit plus ergonomique pour les utilisateurs. Je pense surtout à la mise en avant des messages d'erreur ou d'affichage de confirmations. Malgré tout cela, j'ai tout de même trouvé pertinent de faire des interfaces simples et qui pouvaient être facilement comprises par l'utilisateur.</p>
<h2 id="problemes-rencontres">Problèmes rencontrés</h2>
<p>Je tenais à souligner que la contrainte d'utiliser MarkDown pour la documentation était partiellement compliquée pour des raisons de mise en page d'images, car elle ne me permettait pas de faire autrement que comme j'ai pu le faire tout au long de ce document. Il aurait peut-être été préférable d'utiliser "Word" pour cela.</p>
<p>Les requêtes à l'API m'ont donné du travail en plus, puisqu'il donnait l'impression qu'il ne s'arrêtait jamais après avoir reçu la réponse. L'utilisation de Google Authenticator m'était indispensable, mais son fonctionnement n'est pas très clair, ce qui fait que je devais davantage m'informer et tester ses fonctionnalités.</p>
<p>J'ai tout de même eu du mal au début avec le code asynchrone qui m'était avant tout inconnu. C'est pourquoi du temps a été consacré à devoir me familiariser à l'utiliser.</p>
<p>J'ai eu à maintes reprises dû changer les classes de mon application, puisque la structure des classes n'était pas assez élaborée. La conséquence était, pour le coup, que cela demandait de remanier la plupart de mon code pour adapter mes classes à mon programme.</p>
<h2 id="ameliorations-possibles">Améliorations possibles</h2>
<p>Je le mentionnais ci-dessus, il s'agirait tout d'abord de mettre plus d'affichage de confirmation ou d'erreur. Faire en sorte que les graphiques soient plus explicites et plus précis.
Si on devait mettre cette application en production pour qu'elle soit accessible à tous, je dirais que je devrais tout d'abord changer le mode de cryptage. Le point positif c'est que je me suis déjà renseigné sur ce sujet.</p>
<p>La possibilité d'accepter des cryptomonnaies diverses et variées.Il serait intéressant de faire en sorte que différentes blockchains soient compatibles avec mon application. Il serait également important que les différentes cryptomonnaies présentes dans la blockchain Ethereum soient compatibles. Par le biais de ce qu'on appelle "Swap", qui est l'action d'échanger de l'Ethereum contre un autre coin <a href="https://fr.wikipedia.org/wiki/ERC20">ERC20</a> sur son <a href="https://fr.wikipedia.org/wiki/Contrat_intelligent">smart contract</a>.</p>
<p>Je pense qu'il serait important de mettre en place la phrase mnémonique, qui est la suite de mots qui permettraient de récupérer ses portefeuilles.</p>
<p>Mon application n'a pas de section qui permette à l'utilisateur de modifier sa sécurité et confidentialité. Il serait intéressant de mettre en place la possibilité d'activer ou pas:</p>
<ul>
<li>Affichage des transactions entrantes</li>
<li>Mettre en place une fonction antihameçonnage</li>
<li>Révéler sa phrase secrète après confirmation de son mot de passe.</li>
</ul>
<p>Ajouter un réseau dans mon programme pourrait laisser plus de liberté à l'utilisateur. Du moment où le réseau est conforme aux normes.</p>
<p>Je verrai bien une transformation de mon application pour qu'elle soit aussi sur smartphone.</p>
<p>Pour le moment j'affiche des graphiques simples, il serait vraiment bien de permettre à l'utilisateur d'interagir avec le graphique. Pour que cela soit encore plus interactif, je ferai en sorte de lier l'API “Tradingview” à mon application afin de pouvoir dessiner lui-même sur le graphique. Laisser le choix de la tranche horaire pour le graphique. Mettre plus de possibilités de devises. Possibilités d'afficher son compte sur "Etherscan".</p>
<p>Lier Binance API serait un choix judicieux pour mon application, puisqu'avec celle-ci on pourrait permettre d'accéder aux données du marché. De plus, celle-ci permettrait de mettre en pratique le trading automatique grâce aux ordres que l'utilisateur pourrait enregistrer.</p>
</article>
</div>
</div>
</main>
<footer class="md-footer">
<nav aria-label="Footer" class="md-footer__inner md-grid">
<a aria-label="Previous: Tests" class="md-footer__link md-footer__link--prev" href="../Tests/" rel="prev">
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</div>
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Previous
              </span>
              Tests
            </div>
</div>
</a>
<a aria-label="Next: Journal de bord" class="md-footer__link md-footer__link--next" href="../JournalDeBord/" rel="next">
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Next
              </span>
              Journal de bord
            </div>
</div>
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4z"></path></svg>
</div>
</a>
</nav>
<div class="md-footer-meta md-typeset">
<div class="md-footer-meta__inner md-grid">
<div class="md-footer-copyright">
        
        
          Made with
          <a href="https://squidfunk.github.io/mkdocs-material/" rel="noopener" target="_blank">
            Material for MkDocs
          </a>
 ... <a class="link--pdf-download" download href="../pdf/document.pdf" title="PDF">download PDF</a></div>
</div>
</div>
</footer>
</div>
<div class="md-dialog" data-md-component="dialog">
<div class="md-dialog__inner md-typeset"></div>
</div>
<script id="__config" type="application/json">{"base": "..", "features": [], "translations": {"clipboard.copy": "Copy to clipboard", "clipboard.copied": "Copied to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.placeholder": "Type to start searching", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.term.missing": "Missing", "select.version.title": "Select version"}, "search": "../assets/javascripts/workers/search.fcfe8b6d.min.js", "version": null}</script>
<script src="../assets/javascripts/bundle.b1047164.min.js"></script>
<script src="https://unpkg.com/mermaid@8.5.1/dist/mermaid.min.js"></script>
</body>
</html>